// TODO
// When changing the device in the project settings, this include has to be adjusted accordingly.
// Also make sure to adjust the heap and stack size in startup file.
#include <ARMCM0.h>
#include <cmsis_os2.h>
#include <Application.h>
#include <libredBlocks_sim_uvision.h>
#include <libredBlocks_sim_uvision_rtx.h>

extern void Platform_initSimulation( void );

void applicationThread (void *argument)
{
  rb_sim_uvision_initRtx( 0, 0x30000000, 500, 500 );
  Platform_initSimulation();
  rb_sim_initDone();

  Application_run();

}

/**
 * Main routine of our simulator application. It sets up the single components,
 * associates them with each other and starts the application.
 */
int main()
{
  SystemCoreClock = 8000000UL;
  osKernelInitialize();
  static osThreadAttr_t threadAttr;
  threadAttr.stack_size = 512;
  osThreadNew (applicationThread, NULL, &threadAttr);
  osKernelStart();
  return 0;
}
